﻿--- Version 1.1.5

ZoneLevelCords_Options =
{
	show = true,
	lock = false,
	tooltip = true,
	worldmap = false,
};

function ZoneLevelCords_Message(msg)
	DEFAULT_CHAT_FRAME:AddMessage("ZoneLevelCords"..msg);
end

function ZoneLevelCords_OnLoad(self)
    DEFAULT_CHAT_FRAME:AddMessage("ZoneLevelCords loaded. Please use /zlc options to see the current set of options.")
	SLASH_ZONELEVELCORDS1 = "/zonelevelcords";
	SLASH_ZONELEVELCORDS2 = "/zlc";
	SlashCmdList["ZONELEVELCORDS"] = ZoneLevelCords_SlashCommand;
end

function ZoneLevelCords_OnEvent(self, event, ...)
   if ( event == "ZONE_CHANGED_NEW_AREA" ) then
        SetMapToCurrentZone();
   end
end

function ZoneLevelCords_SlashCommand(arg1)
  if (arg1 == "options") or (arg1 == "") or (arg1 == "settings") then
    DEFAULT_CHAT_FRAME:AddMessage("ZLC:Options are...")
    DEFAULT_CHAT_FRAME:AddMessage("/zlc unlock/lock")
    DEFAULT_CHAT_FRAME:AddMessage("/zlc show or /zlc hide")
    DEFAULT_CHAT_FRAME:AddMessage("/zlc bug")
    DEFAULT_CHAT_FRAME:AddMessage("/zlc disable")-- Not really just hides the addon...this way if they want to turn back on, it will still be there.
    DEFAULT_CHAT_FRAME:AddMessage("/zlc enable")
    DEFAULT_CHAT_FRAME:AddMessage("/zlc tooltip hide/show")
    DEFAULT_CHAT_FRAME:AddMessage("/zlc config -- opens the config window.")
    DEFAULT_CHAT_FRAME:AddMessage("Please remember this addon is in development and being improved everyday. We are doing our best to improve it. If you wish to help, email ideas and post comments. Thank you")
  elseif(arg1 == "lock") then
    DEFAULT_CHAT_FRAME:AddMessage("ZLC:Addon is now locked")
    ZoneLevelCords_Options.lock = true;
  elseif(arg1 == "unlock") then
    DEFAULT_CHAT_FRAME:AddMessage("ZLC:Addon is now unlocked")
    ZoneLevelCords_Options.lock = false;
  elseif(arg1 == "bug") or (arg1 == "debug") then
    DEFAULT_CHAT_FRAME:AddMessage("ZLC:If you find a bug, please report it using the bug report tool found on wowinterface.com -- Thank you.")
  elseif(arg1 == "show") or (arg1 == "hide") then
    if(ZoneLevelCords_Frame:IsShown()) then
       ZoneLevelCords_Frame:Hide();
       DEFAULT_CHAT_FRAME:AddMessage("ZLC:Hiding Addon.")
    else
       ZoneLevelCords_Frame:Show();
       DEFAULT_CHAT_FRAME:AddMessage("ZLC:Showing Addon.")
    end
  elseif(arg1 == "disable") then
       ZoneLevelCords_Frame:Hide();
       DEFAULT_CHAT_FRAME:AddMessage("ZLC:Addon Disabled.")
  elseif(arg1 == "enable") then
       ZoneLevelCords_Frame:Show();
       ZoneLevelCords_Options.lock = false;
       DEFAULT_CHAT_FRAME:AddMessage("ZLC:Enabling addon.")
  elseif(arg1 == "todo") then
       DEFAULT_CHAT_FRAME:AddMessage("ZLC:Nothing.")
  elseif(arg1 == "tooltip hide") then
       DEFAULT_CHAT_FRAME:AddMessage("ZLC:Hiding Tooltip.")
       ZoneLevelCords_Options.tooltip = false;
  elseif(arg1 == "tooltip show") then
       DEFAULT_CHAT_FRAME:AddMessage("ZLC:Showing Tooltip.")
       ZoneLevelCords_Options.tooltip = true;
  elseif(arg1 == "tooltip") or (arg1 == "tool") then
       DEFAULT_CHAT_FRAME:AddMessage("ZLC:Use /zlc tooltip hide or /zlc tooltip show to hide or show it.")
  elseif(arg1 == "config") then
       if(ZLCConfigFrame:IsShown()) then
         ZLCConfigFrame:Hide()
       else
         ZLCConfigFrame:Show()
       end
  else
       DEFAULT_CHAT_FRAME:AddMessage("ZLC:Not a valid slash command. Please use /zlc options to get a list.")
  end
end

local function round(num, idp)
	local mult = 10 ^ (idp or 0);
	return math.floor(num * mult + 0.5) / mult;
end

function ZoneLevelCords_OnUpdate(self, elapsed)
	local x, y = GetPlayerMapPosition("player");
	local text;
	if(x == 0 and y == 0)then
		text = "N/A";
	else
		x = round(x * 100, 2);
		y = round(y * 100, 2);
		text = string.format("%.2f, %.2f", x, y);
	end
	ZoneLevelCords_Frame_Text:SetText(text);
	getglobal(self:GetName().."_Text"):SetText(text);
end

function ZoneLevelCords_OnEnter(self)
	if(ZoneLevelCords_Options.tooltip)then
		GameTooltip_SetDefaultAnchor(GameTooltip, self);
		GameTooltip:SetText(ZONELEVELCORDS_TOOLTIP_TITLE);
		GameTooltip:AddLine(ZONELEVELCORDS_TOOLTIP_SUBTITLE);
		if(ZoneLevelCords_Options.lock)then
			GameTooltip:AddLine(ZONELEVELCORDS_TOOLTIP_LOCKED);
		else
			GameTooltip:AddLine(ZONELEVELCORDS_TOOLTIP_LEFTCLICK);
		end
		GameTooltip:AddLine(ZONELEVELCORDS_TOOLTIP_RIGHTCLICK);
		GameTooltipTextLeft1:SetTextColor(1, 1, 1);
		GameTooltipTextLeft2:SetTextColor(1, 1, 1);
		GameTooltip:Show();
	end
end

ZLCConfigFrame = CreateFrame("Frame", ZLCConfigFrame, WorldFrame)
ZLCConfigFrame:SetWidth(300)
ZLCConfigFrame:SetHeight(200)
ZLCConfigFrame:ClearAllPoints()
ZLCConfigFrame:SetBackdrop(StaticPopup1:GetBackdrop())
ZLCConfigFrame:SetFrameStrata("HIGH")
ZLCConfigFrame:SetClampedToScreen(true)
ZLCConfigFrame:SetMovable(true)
ZLCConfigFrame:EnableMouse(true)
ZLCConfigFrame:Hide()
ZLCConfigFrame:SetScript("OnMouseDown",function()
  ZLCConfigFrame:StartMoving()
end)
ZLCConfigFrame:SetScript("OnMouseUp",function()
  ZLCConfigFrame:StopMovingOrSizing()
end)

ZLCConfigFrame.text = ZLCConfigFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
ZLCConfigFrame.text:SetPoint("TOP",ZLCConfigFrame,"TOP", 0,-15)
ZLCConfigFrame.text:SetText("ZoneLevelCords")
ZLCConfigFrame:SetPoint("CENTER", 0, 0)

ZLCConfigFrame.textt = ZLCConfigFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
ZLCConfigFrame.textt:SetPoint("TOP",ZLCConfigFrame,"TOP", 0,-35)
ZLCConfigFrame.textt:SetText("Options")
ZLCConfigFrame:SetPoint("CENTER", 0, 0)

ZLCConfigFrame.btnexit = CreateFrame("BUTTON", nil, ZLCConfigFrame, "UIPanelButtonTemplate")
ZLCConfigFrame.btnexit:SetWidth(20)
ZLCConfigFrame.btnexit:SetHeight(20)
ZLCConfigFrame.btnexit:SetPoint("TOP", ZLVLCONFIG, "TOP", 125,-60)
ZLCConfigFrame.btnexit:SetText("X")
ZLCConfigFrame.btnexit:SetPoint("CENTER", ZLVLCONFIG, "CENTER")
ZLCConfigFrame.btnexit:SetScript("OnClick", function() if(ZLCConfigFrame:Show()) then ZLCConfigFrame:Hide() elseif(ZLCConfigFrame:Hide()) then ZLCConfigFrame:Show() end end)
ZLCConfigFrame.btnexit:SetAlpha(1)
ZLCConfigFrame.btnexit:Show()

ZLCConfigFrame.btn = CreateFrame("BUTTON", nil, ZLCConfigFrame, "UIPanelButtonTemplate")
ZLCConfigFrame.btn:SetWidth(100)
ZLCConfigFrame.btn:SetHeight(22)
ZLCConfigFrame.btn:SetPoint("TOP", ZLCConfigFrame, "TOP", -75,-64)
ZLCConfigFrame.btn:SetText("Tooltip")
ZLCConfigFrame.btn:SetPoint("CENTER", MyFrame, "CENTER")
ZLCConfigFrame.btn:SetScript("OnClick", function() if(ZoneLevelCords_Options.tooltip == false) then print("Showing tooltip.") ZoneLevelCords_Options.tooltip = true; elseif(ZoneLevelCords_Options.tooltip == true) then print("Hiding tooltip.") ZoneLevelCords_Options.tooltip = false; end end)
ZLCConfigFrame.btn:SetAlpha(1)
ZLCConfigFrame.btn:Show()

ZLCConfigFrame.btna = CreateFrame("BUTTON", nil, ZLCConfigFrame, "UIPanelButtonTemplate")
ZLCConfigFrame.btna:SetWidth(100)
ZLCConfigFrame.btna:SetHeight(22)
ZLCConfigFrame.btna:SetPoint("TOP", ZLCConfigFrame, "TOP", -75,-94)
ZLCConfigFrame.btna:SetText("Lock/Unlock")
ZLCConfigFrame.btna:SetPoint("CENTER", ZLCConfigFrame, "CENTER")
ZLCConfigFrame.btna:SetScript("OnClick", function() if(ZoneLevelCords_Options.lock == false) then print("Locking window.") ZoneLevelCords_Options.lock = true; elseif(ZoneLevelCords_Options.lock == true) then print("Unlocking Window.") ZoneLevelCords_Options.lock = false; end end)
ZLCConfigFrame.btna:SetAlpha(1)
ZLCConfigFrame.btna:Show()

ZLCConfigFrame.btnb = CreateFrame("BUTTON", nil, ZLCConfigFrame, "UIPanelButtonTemplate")
ZLCConfigFrame.btnb:SetWidth(100)
ZLCConfigFrame.btnb:SetHeight(22)
ZLCConfigFrame.btnb:SetPoint("TOP", ZLCConfigFrame, "TOP", -75,-124)
ZLCConfigFrame.btnb:SetText("Hide")
ZLCConfigFrame.btnb:SetPoint("CENTER", ZLCConfigFrame, "CENTER")
ZLCConfigFrame.btnb:SetScript("OnClick", function() if(ZoneLevelCords_Options.show == false) then print("Hiding window.") ZoneLevelCords_Options.show = true; elseif(ZoneLevelCords_Options.show == true) then print("Showing Window.") ZoneLevelCords_Options.show = false; end end)
ZLCConfigFrame.btnb:SetAlpha(1)
ZLCConfigFrame.btnb:Show()

ZLCConfigFrame.btnb = CreateFrame("BUTTON", nil, ZLCConfigFrame, "UIPanelButtonTemplate")
ZLCConfigFrame.btnb:SetWidth(100)
ZLCConfigFrame.btnb:SetHeight(22)
ZLCConfigFrame.btnb:SetPoint("TOP", ZLCConfigFrame, "TOP", -75,-154)
ZLCConfigFrame.btnb:SetText("Enable/Disable")
ZLCConfigFrame.btnb:SetPoint("CENTER", ZLCConfigFrame, "CENTER")
ZLCConfigFrame.btnb:SetScript("OnClick", function() if(ZoneLevelCords_Options.show == false) then print("Disabling Addon.") ZoneLevelCords_Options.show = true; elseif(ZoneLevelCords_Options.show == true) then print("Enabling Window.") ZoneLevelCords_Options.show = false; end end)
ZLCConfigFrame.btnb:SetAlpha(1)
ZLCConfigFrame.btnb:Show()
